﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.UI.DataVisualization.Charting

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Dim query As String = "SELECT DISTINCT ShipCountry FROM Orders"
            Dim dt As DataTable = GetData(query)
            ddlCountries.DataSource = dt
            ddlCountries.DataTextField = "ShipCountry"
            ddlCountries.DataValueField = "ShipCountry"
            ddlCountries.DataBind()
            ddlCountries.Items.Insert(0, New ListItem("Select Country", ""))
        End If
    End Sub

    Private Shared Function GetData(ByVal query As String) As DataTable
        Dim constr As String = ConfigurationManager.ConnectionStrings("ConString").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query)
                Dim dt As DataTable = New DataTable()
                Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                    sda.Fill(dt)
                End Using

                Return dt
            End Using
        End Using
    End Function

    Protected Sub PopulateChart(ByVal sender As Object, ByVal e As EventArgs)
        Chart1.Visible = ddlCountries.SelectedValue <> ""
        Dim query As String = String.Format("SELECT ShipCity, COUNT(OrderId) [Total] FROM Orders WHERE ShipCountry = '{0}' GROUP BY ShipCity", ddlCountries.SelectedValue)
        Dim dt As DataTable = GetData(query)
        Chart1.DataSource = dt
        Chart1.Series(0).ChartType = CType(Integer.Parse(rblChartType.SelectedItem.Value), SeriesChartType)
        Chart1.Legends(0).Enabled = True
        Chart1.Series(0).XValueMember = "ShipCity"
        Chart1.Series(0).YValueMembers = "Total"
        Chart1.DataBind()
    End Sub
End Class
